part of katana_module;

/// Config class for forms.
@immutable
abstract class FormConfig<T> {
  const FormConfig();

  /// Specifies a callback for just displaying the value.
  Iterable<Widget> view({
    required BuildContext context,
    required WidgetRef ref,
    required VariableConfig<T> config,
    DynamicMap? data,
    bool onlyRequired = false,
  });

  /// Specifies the callback for displaying the form.
  Iterable<Widget> form({
    required VariableConfig<T> config,
    required BuildContext context,
    required WidgetRef ref,
    DynamicMap? data,
    bool onlyRequired = false,
  });

  /// Callback to retrieve values when processing form content.
  T? value({
    required VariableConfig<T> config,
    required BuildContext context,
    required WidgetRef ref,
    bool updated = true,
  });

  Iterable<Widget> _view({
    required BuildContext context,
    required WidgetRef ref,
    required VariableConfig config,
    DynamicMap? data,
    bool onlyRequired = false,
  }) =>
      view(
        context: context,
        ref: ref,
        config: config as VariableConfig<T>,
        data: data,
        onlyRequired: onlyRequired,
      );

  Iterable<Widget> _form({
    required VariableConfig config,
    required BuildContext context,
    required WidgetRef ref,
    DynamicMap? data,
    bool onlyRequired = false,
  }) =>
      form(
        context: context,
        ref: ref,
        config: config as VariableConfig<T>,
        data: data,
        onlyRequired: onlyRequired,
      );

  T? _value({
    required VariableConfig config,
    required BuildContext context,
    required WidgetRef ref,
    bool updated = true,
  }) =>
      value(
        context: context,
        ref: ref,
        config: config as VariableConfig<T>,
        updated: updated,
      );
}
